package cokr.xit.fims.cmmn.web;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import cokr.xit.foundation.web.AbstractController;

import cokr.xit.fims.cmmn.CrdnSttsHstry;
import cokr.xit.fims.cmmn.CrdnSttsHstryQuery;
import cokr.xit.fims.cmmn.service.CrdnSttsHstryService;

/**단속 상태 이력 서비스의 웹 컨트롤러
 *
 * <p>상세 설명:
 *
 * <pre>
 * ============ 변경 이력 ============
 * 2023-07-19	JoJH 최초 작성
 * ================================
 * </pre>
 */
@RequestMapping(name = "단속 상태 이력", value = "/crdnSttsHstry")
public class CrdnSttsHstryController extends AbstractController {

	/**단속 상태 이력 서비스*/
	@Resource(name = "crdnSttsHstryService")
	private CrdnSttsHstryService crdnSttsHstryService;

	/**단속 상태 이력 관리 메인화면(crdnSttsHstry/crdnSttsHstry-main)을 연다.
	 * 조건없는 {@link #getCrdnSttsHstryList(CrdnSttsHstryQuery) 단속 상태 이력 조회 결과}를 포함시킨다.
	 * @return /crdnSttsHstry/crdnSttsHstry-main
	 */
	@RequestMapping(name = "단속 상태 이력 메인", value = "/main.do")
	public ModelAndView main() {
		ModelAndView mav = getCrdnSttsHstryList(new CrdnSttsHstryQuery().setPageNum(1));
		mav.setViewName("/crdnSttsHstry/crdnSttsHstry-main");
		return mav.addObject("crdnSttsHstryList", toJson(mav.getModel().get("crdnSttsHstryList")));
	}

	/**단속 상태 이력 목록을 조회하여 반환한다.<br />
	 * {@link CrdnSttsHstryService#getCrdnSttsHstryList(CrdnSttsHstryQuery)} 참고
	 * @param req 단속 상태 이력 조회 조건
	 * @return jsonView
	 * <pre><code> {
	 *     "crdnSttsHstryList": [단속 상태 이력 목록]
	 *     "crdnSttsHstryStart": 단속 상태 이력 목록 시작 인덱스
	 *     "crdnSttsHstryFetch": 한 번에 가져오는 단속 상태 이력 목록 수
	 *     "crdnSttsHstryTotal": 조회 결과 찾은 전체 단속 상태 이력 수
	 * }</code></pre>
	 */
	@RequestMapping(name = "단속 상태 이력 조회", value = "/list.do")
	public ModelAndView getCrdnSttsHstryList(CrdnSttsHstryQuery req) {
		List<?> result = crdnSttsHstryService.getCrdnSttsHstryList(setFetchSize(req));
		return setCollectionInfo(new ModelAndView("jsonView"), result, "crdnSttsHstry");
	}

	/**단속 상태 이력를 등록한다.
	 * @param crdnSttsHstry 단속 상태 이력 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 등록되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "단속 상태 이력 등록", value = "/create.do")
	public ModelAndView create(CrdnSttsHstry crdnSttsHstry) {
		boolean saved = crdnSttsHstryService.create(crdnSttsHstry);
		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**단속 상태 이력 정보를 수정한다.
	 * @param crdnSttsHstry 단속 상태 이력 정보
	 * @return jsonView
	 * <pre><code> {
	 *     "saved": 수정되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "단속 상태 이력 수정", value = "/update.do")
	public ModelAndView update(CrdnSttsHstry crdnSttsHstry) {
		boolean saved = crdnSttsHstryService.update(crdnSttsHstry);
		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}

	/**지정한 단속 상태 이력를 제거한다.
	 * @param crdnSttsHstryIDs 단속 상태 이력 아이디
	 * @return jsonView
	 * <pre><code> {
	 *     "affected": 저장된 정보수
	 *     "saved": 저장되었으면 true, 그렇지 않으면 false
	 * }</code></pre>
	 */
	@PostMapping(name = "단속 상태 이력 제거", value = "/remove.do")
	public ModelAndView remove(CrdnSttsHstry crdnSttsHstry) {
		boolean saved = crdnSttsHstryService.remove(crdnSttsHstry);
		return new ModelAndView("jsonView")
			.addObject("saved", saved);
	}
}
